package com.chinaitop.depot;

import org.activiti.spring.boot.SecurityAutoConfiguration;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.autoconfigure.jdbc.DataSourceAutoConfiguration;
import org.springframework.boot.web.servlet.ServletRegistrationBean;
import org.springframework.cache.annotation.EnableCaching;
import org.springframework.cloud.client.discovery.EnableDiscoveryClient;
import org.springframework.cloud.netflix.eureka.EnableEurekaClient;
import org.springframework.cloud.openfeign.EnableFeignClients;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.scheduling.concurrent.ThreadPoolTaskScheduler;
import org.springframework.session.data.redis.config.annotation.web.http.EnableRedisHttpSession;
import org.springframework.web.context.support.AnnotationConfigWebApplicationContext;
import org.springframework.web.servlet.DispatcherServlet;

import springfox.documentation.swagger2.annotations.EnableSwagger2;


@EnableEurekaClient
@EnableDiscoveryClient
@EnableCaching
@EnableRedisHttpSession
@EnableFeignClients
@EnableSwagger2
@SpringBootApplication(
		//exclude = {DataSourceAutoConfiguration.class}	// 禁止自动配置数据源，多数据源需采用手动配置
		exclude = SecurityAutoConfiguration.class

	)
@MapperScan(basePackages = {"com.chinaitop.depot.*.mapper"})
public class DepotBusinessApplication {

	public static void main(String[] args) {
		SpringApplication.run(DepotBusinessApplication.class, args);
	}
	
	
	/**
	 * 注册一个dispatcherServlet,解决增加ws之后https接口访问不了问题
	 */
	/*@Bean
	public ServletRegistrationBean restServlet(){
		//注解扫描上下文
		AnnotationConfigWebApplicationContext applicationContext = new AnnotationConfigWebApplicationContext();
		//base package
		applicationContext.scan("com.chinaitop.depot.unissoft");
		//通过构造函数指定dispatcherServlet的上下文
		DispatcherServlet rest_dispatcherServlet = new DispatcherServlet(applicationContext);
		//用ServletRegistrationBean包装servlet
		ServletRegistrationBean registrationBean = new ServletRegistrationBean(rest_dispatcherServlet);
		registrationBean.setLoadOnStartup(1);
		//指定urlmapping
		registrationBean.addUrlMappings("/*");
		//指定name，如果不指定默认为dispatcherServlet
		registrationBean.setName("rest");
		return registrationBean;
	}
*/
	/*@Bean
	public ThreadPoolTaskScheduler threadPoolTaskScheduler() {
		return new ThreadPoolTaskScheduler();
	}*/
	

}
